//-------at_ch_LR0----------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 MediumSlateBlue
#property indicator_color2 MediumSlateBlue
//======================================
extern int SQ_max=50;
extern double hrHL=24; //      
extern bool SPR=false; //   
extern int cbn=3000;
extern double ksq  = 1;
//======================================
double hh[],ll[];
double spr,ss,ssp,hm,lm;
int p,ai,bi,fs,t0;
//-------------------
double sq_max,aa,bb,sq,kt,v;
int x1,x2,f,fstart;
string name;
//********************************************************************
int init() 
{
   SetIndexBuffer(0,hh);
   SetIndexBuffer(1,ll);
   //====================
   if (SPR) spr=MarketInfo(Symbol(),MODE_SPREAD)*Point; else spr=0.0;
   p=hrHL*60/Period(); sq_max=SQ_max*Point; kt=60.0/Period();
   name="RCh"+SQ_max;
   return(0); 
}
//********************************************************************
int start()
{
   int cbi,IC=Bars-IndicatorCounted()-1;
   if (IC<20) cbi=IC; else 
   {
      if (cbn==0) cbi=Bars-p-1; else cbi=cbn; 
       
      hm=High[cbi]; lm=Low[cbi]; ssp=(hm+lm)/2; 
      x2=cbi+p; ai=x2; bi=x2; fs=1; f=0; t0=Time[0];
   } 
   //------------------------------------ 
   if (t0!=Time[0]) {x2++; if (ai!=0) ai++; if (bi!=0) bi++; t0=Time[0];}
   for(int i=cbi; i>=0; i--) 
   { 
      hh[i]=High[iHighest(NULL,0,MODE_HIGH,p,i)]+spr;
      ll[i]=Low[iLowest(NULL,0,MODE_LOW,p,i)];
      
      ss=(hh[i]+ll[i])/2; ssp=(hh[i+1]+ll[i+1])/2;
      
      if (ss>ssp) {if (fs==2) {hm=hh[i]; ai=i;} fs=1;} 
      if (ss<ssp) {if (fs==1) {lm=ll[i]; bi=i;} fs=2;} 
      
      if (hh[i]>hm) {hm=hh[i]; ai=i;}
      if (ll[i]<lm) {lm=ll[i]; bi=i;}
      
      af_lrsq(x2-i,i);
      
      if (sq>sq_max) 
      {
         x1=i+1; 
         af_lrsq(x2-x1,x1);
         af_draw(x2,x1);
         if (fs==1) {if (x2!=bi) x2=bi; else x2=ai;} 
         if (fs==2) {if (x2!=ai) x2=ai; else x2=bi;}  
      }
      
   }
   x1=0; 
   af_lrsq(x2,x1); 
   af_draw(x2,x1);
   v=-aa*x2/Point/(x2/kt);
   //---------------------------------------------
   Comment
   (
      "ai= ",ai,"\n",
      "bi= ",bi,"\n",
      "v= ",DoubleToStr(v,1),
      "\n","sq= ",DoubleToStr(sq/Point,1)
   );
   //---------------------------------------------
   return(0);
}
//**********************************************************************
void af_lrsq(int p,int i)
{
   double sx,sy,sxy,sxx,dc;
   //------------------------
   if (p<3) p=3; 
   p=p+1;
   
   sx=0.0; sy=0.0; sxy=0.0; sxx=0.0; 
   for (int n=0; n<p; n++) 
   {
      sx+=n; 
      sy+=Close[n+i]; 
      sxy+=n*Close[n+i]; 
      sxx+=n*n; 
   }   
   aa=(sx*sy-p*sxy)/(sx*sx-p*sxx);
   bb=(sy-aa*sx)/p;
  
   sq=0.0;
   for (n=0; n<p; n++) 
   {
      dc=Close[i+n]-bb-aa*n;
      sq+=dc*dc;
   }
   sq=MathSqrt(sq/p); 
}
//***************************************************************
void af_draw(int x2,int x1)
{
   static int ff=0;
   color col;
   if (-aa>=0) col=Blue; else if (-aa<0) col=Orange; 
   if (x1>0)
   {
      ObjectCreate(name+Time[x1],4,0,Time[x2],0,Time[x1],0);
      ObjectSet(name+Time[x1],OBJPROP_COLOR,col);
   }
   else
   { 
      if (ff==1) {ObjectMove(name,0,Time[x2],0); ObjectMove(name,1,Time[x1],0);} 
      else {ObjectCreate(name,4,0,Time[x2],0,Time[x1],0); ObjectSet(name,OBJPROP_COLOR,Red); ff=1;}
   }
}
//***************************************************************
int deinit() 
{
   for (int i=Bars-1; i>=0; i--) ObjectDelete(name+Time[i]); 
   ObjectDelete(name);
   return(0);
}
//*************************************************  